<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="计划名称" prop="planName">
        <el-input
          v-model="queryParams.planName"
          placeholder="请输入计划名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="计划编号" prop="planCode">
        <el-input
          v-model="queryParams.planCode"
          placeholder="请输入计划编号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="创建时间">
        <el-date-picker
          v-model="dateRange"
          size="small"
          style="width: 240px"
          value-format="yyyy-MM-dd"
          type="daterange"
          range-separator="-"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
        ></el-date-picker>
      </el-form-item>
      <el-form-item label="计划状态" prop="planStatus">
        <el-select v-model="queryParams.planStatus" placeholder="请选择计划状态" clearable size="small">
          <el-option
            v-for="dict in statusOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="maintainPlanList">
      <el-table-column label="计划名称" align="center" prop="planName" />
      <el-table-column label="计划编号" align="center" prop="planCode" />
      <el-table-column label="计划开始时间" align="center" prop="planStartTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.planStartTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="计划结束时间" align="center" prop="planEndTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.planEndTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="保养内容" align="center" prop="maintainContent" />
      <el-table-column label="计划状态" align="center" prop="planStatus" :formatter="statusFormat" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            v-if="scope.row.planStatus == '0'"
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
          >修改</el-button>
          <el-button
            v-if="scope.row.planStatus == '0'"
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleConfirm(scope.row)"
          >确认保养</el-button>
          <el-button
            v-if="scope.row.planStatus == '1'"
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleMaintain(scope.row)"
          >保养完成</el-button>
          <el-button
            v-if="scope.row.planStatus == '2'"
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleCheck(scope.row)"
          >验收</el-button>
          <el-button
            v-if="scope.row.planStatus == '0'"
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改设备保养计划对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-row>
          <el-col :span="11">
            <el-form-item label="计划名称" prop="planName">
              <el-input v-model="form.planName" placeholder="请输入计划名称" :disabled="readOnly" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="特种设备" prop="devices">
              <el-select v-model="form.devices" placeholder="请选择特种设备" multiple filterable clearable style="width: 100%" :disabled="readOnly">
                <el-option
                  v-for="item in specialDeviceList"
                  :key="item.id"
                  :label="item.deviceName"
                  :value="item.id"
                ></el-option>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="11">
            <el-form-item label="计划开始时间" prop="planStartTime">
              <el-date-picker clearable size="small"
                              v-model="form.planStartTime"
                              type="date"
                              value-format="yyyy-MM-dd"
                              placeholder="选择计划开始时间"
                              style="width: 100%"
                              :disabled="readOnly">
              </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="计划结束时间" prop="planEndTime">
              <el-date-picker clearable size="small"
                              v-model="form.planEndTime"
                              type="date"
                              value-format="yyyy-MM-dd"
                              placeholder="选择计划结束时间"
                              style="width: 100%"
                              :disabled="readOnly">
              </el-date-picker>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="23">
            <el-form-item label="保养内容" prop="maintainContent">
              <el-input type="textarea" v-model="form.maintainContent" placeholder="请输入保养内容" :disabled="readOnly" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row v-show="operate">
          <el-col :span="23">
            <el-form-item label="验收结果" prop="planStatus">
              <el-radio v-model="form.planStatus" label="3">通过</el-radio>
              <el-radio v-model="form.planStatus" label="0">未通过</el-radio>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="23">
            <el-form-item label="备注信息" prop="remarks">
              <el-input type="textarea" v-model="form.remarks" placeholder="请输入备注信息" :disabled="!readOnly" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listMaintainPlan, getMaintainPlan, delMaintainPlan, addMaintainPlan, updateMaintainPlan, exportMaintainPlan } from "@/api/deviceManagement/maintainPlan";
import { listSpecial } from "@/api/deviceManagement/deviceInfo";

export default {
  name: "MaintainPlan",
  components: {
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 设备保养计划表格数据
      maintainPlanList: [],
      // 特种设备列表
      specialDeviceList: [],
      statusOptions: [],
      // 日期范围
      dateRange: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      operate: false,
      readOnly: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        planName: null,
        planCode: null,
        deviceId: null,
        planStartTime: null,
        planEndTime: null,
        maintainContent: null,
        planStatus: null,
        isDel: null,
        updateTime: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        planName: [
          { required: true, message: "请输入计划名称", trigger: "blur" }
        ],
        planStartTime: [
          { required: true, message: "请选择计划开始时间", trigger: "blur" }
        ],
        planEndTime: [
          { required: true, message: "请选择计划结束时间", trigger: "blur" }
        ],
        devices: [
          { required: true, message: "请选择特种设备", trigger: "blur" }
        ],
        maintainContent: [
          { required: true, message: "请输入保养内容", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
    this.getSpecialDeviceList();
    this.getDicts("t_plan_status").then(response => {
      this.statusOptions = response.data;
    });
  },
  methods: {
    // 计划状态
    statusFormat(row, column) {
      return this.selectDictLabel(this.statusOptions, row.planStatus);
    },
    /** 查询设备保养计划列表 */
    getList() {
      this.loading = true;
      listMaintainPlan(this.addDateRange(this.queryParams, this.dateRange)).then(response => {
        this.maintainPlanList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    getSpecialDeviceList() {
      this.loading = true;
      listSpecial().then(response => {
        this.specialDeviceList = response.data;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        planName: null,
        planCode: null,
        deviceId: null,
        planStartTime: null,
        planEndTime: null,
        maintainContent: null,
        planStatus: null,
        isDel: null,
        createTime: null,
        updateTime: null,
        remarks: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.readOnly=false;
      this.operate=false;
      this.reset();
      this.open = true;
      this.title = "添加设备保养计划";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.readOnly = false;
      this.operate = false;
      this.reset();
      const id = row.id || this.ids
      getMaintainPlan(id).then(response => {
        this.form = response.data;
        var arr = this.form.deviceId.split(",");
        this.form.devices = arr.map(Number);
        console.log(this.form.devices);
        this.open = true;
        this.title = "修改设备保养计划";
      });
    },
    /** 验收按钮操作 */
    handleCheck(row) {
      this.readOnly = true;
      this.reset();
      const id = row.id || this.ids
      getMaintainPlan(id).then(response => {
        this.form = response.data;
        var arr = this.form.deviceId.split(",");
        this.form.devices = arr.map(Number);
        this.form.planStatus = '3';
        this.operate = true;
        this.open = true;
        this.title = "验收设备保养计划";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          console.log(this.form.devices);
          this.form.deviceId = this.form.devices.toString();
          if (this.form.id != null) {
            if(this.operate) {
              updateMaintainPlan(this.form).then(response => {
                this.msgSuccess("验收成功");
                this.open = false;
                this.operate = false;
                this.readOnly = false;
                this.getList();
              });
            } else {
              updateMaintainPlan(this.form).then(response => {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              });
            }
          } else {
            addMaintainPlan(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 确认保养按钮操作 */
    handleConfirm(row) {
      // const ids = row.id || this.ids;
      this.$confirm('是否确认开始执行编号为"' + row.planCode + '"的设备保养计划?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          row.planStatus = '1';
          return updateMaintainPlan(row);
        }).then(() => {
          this.getList();
          this.msgSuccess("确认成功");
        }).catch(() => {});
    },
    /** 保养完成按钮操作 */
    handleMaintain(row) {
      // const ids = row.id || this.ids;
      this.$confirm('是否确认完成编号为"' + row.planCode + '"的设备保养计划?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          row.planStatus = '2';
          return updateMaintainPlan(row);
        }).then(() => {
          this.getList();
          this.msgSuccess("确认成功");
        }).catch(() => {});
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      // const ids = row.id || this.ids;
      this.$confirm('是否确认删除设备保养计划编号为"' + row.planCode + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          row.isDel = '1';
          return updateMaintainPlan(row);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
  }
};
</script>
